//
// ApiAlerteAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Alamofire



open class ApiAlerteAPI: APIBase {
    /**
     * enum for parameter typeEvenement
     */
    public enum TypeEvenement_apiAlerteAjouterEvenementPost: String { 
        case actSoupcon = "ACT_SOUPCON"
        case actDangerAvere = "ACT_DANGER_AVERE"
        case actConfirme = "ACT_CONFIRME"
        case actAnnule = "ACT_ANNULE"
        case obsDanger = "OBS_DANGER"
        case obsCallok = "OBS_CALLOK"
        case obsRas = "OBS_RAS"
        case obsPolice = "OBS_POLICE"
        case obsOkmerci = "OBS_OKMERCI"
        case obsVerif = "OBS_VERIF"
    }

    /**
     Ajoute un événement
     
     - parameter idAlerte: (query)  
     - parameter typeEvenement: (query)  
     - parameter nomFoyerEmetteur: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiAlerteAjouterEvenementPost(idAlerte: String, typeEvenement: TypeEvenement_apiAlerteAjouterEvenementPost, nomFoyerEmetteur: String, completion: @escaping ((_ error: Error?) -> Void)) {
        apiAlerteAjouterEvenementPostWithRequestBuilder(idAlerte: idAlerte, typeEvenement: typeEvenement, nomFoyerEmetteur: nomFoyerEmetteur).execute { (response, error) -> Void in
            completion(error);
        }
    }


    /**
     Ajoute un événement
     - POST /apiAlerte/ajouterEvenement
     - Ajoute un événement spécifique à une alerte voisinage
     - BASIC:
       - type: basic
       - name: Basic
     
     - parameter idAlerte: (query)  
     - parameter typeEvenement: (query)  
     - parameter nomFoyerEmetteur: (query)  

     - returns: RequestBuilder<Void> 
     */
    open class func apiAlerteAjouterEvenementPostWithRequestBuilder(idAlerte: String, typeEvenement: TypeEvenement_apiAlerteAjouterEvenementPost, nomFoyerEmetteur: String) -> RequestBuilder<Void> {
        let path = "/apiAlerte/ajouterEvenement"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "idAlerte": idAlerte,
            "typeEvenement": typeEvenement.rawValue,
            "nomFoyerEmetteur": nomFoyerEmetteur
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Récupère une alerte
     
     - parameter idAlerte: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiAlerteGetAlerteGet(idAlerte: String, completion: @escaping ((_ data: [Alerte]?,_ error: Error?) -> Void)) {
        apiAlerteGetAlerteGetWithRequestBuilder(idAlerte: idAlerte).execute { (response, error) -> Void in
            completion(response?.body, error);
        }
    }


    /**
     Récupère une alerte
     - GET /apiAlerte/getAlerte
     - Permet de récupérer une alerte de sécurité dans le voisinage
     - BASIC:
       - type: basic
       - name: Basic
     - examples: [{contentType=application/json, example=[ {
  "foyerEmetteur" : {
    "identifiantUnique" : "aeiou",
    "abonnementQuartier" : [ {
      "alertes" : [ "" ],
      "marie" : "aeiou",
      "id" : "aeiou",
      "nom" : "aeiou",
      "tous" : true
    } ],
    "utilisateurs" : [ {
      "id" : "aeiou",
      "nom" : "aeiou",
      "prenom" : "aeiou"
    } ],
    "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
    "dateCreated" : "2000-01-23T04:56:07.000+00:00",
    "immeuble" : {
      "latitude" : "aeiou",
      "adresse" : "aeiou",
      "id" : "",
      "longitude" : "aeiou"
    },
    "id" : "aeiou",
    "nom" : "aeiou",
    "numeroTelephone" : "aeiou",
    "uuid" : [ "aeiou" ]
  },
  "dateCreated" : "2000-01-23T04:56:07.000+00:00",
  "etatCourant" : "aeiou",
  "typeAlerte" : "aeiou",
  "evenements" : [ {
    "dateCreated" : "2000-01-23T04:56:07.000+00:00",
    "typeEvenement" : "aeiou",
    "nomFoyerEmetteur" : "aeiou"
  } ],
  "id" : "aeiou",
  "foyerImpacte" : ""
} ]}]
     
     - parameter idAlerte: (query)  

     - returns: RequestBuilder<[Alerte]> 
     */
    open class func apiAlerteGetAlerteGetWithRequestBuilder(idAlerte: String) -> RequestBuilder<[Alerte]> {
        let path = "/apiAlerte/getAlerte"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "idAlerte": idAlerte
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Alerte]>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     Récupère une alerte proche
     
     - parameter idFoyer: (query)  
     - parameter delta: (query)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiAlerteGetAlertesProchesGet(idFoyer: String, delta: Int32, completion: @escaping ((_ data: [Alerte]?,_ error: Error?) -> Void)) {
        apiAlerteGetAlertesProchesGetWithRequestBuilder(idFoyer: idFoyer, delta: delta).execute { (response, error) -> Void in
            completion(response?.body, error);
        }
    }


    /**
     Récupère une alerte proche
     - GET /apiAlerte/getAlertesProches
     - Permet de récupérer une alerte de sécurité dans le voisinage en fonction d'un delta
     - BASIC:
       - type: basic
       - name: Basic
     - examples: [{contentType=application/json, example=[ {
  "foyerEmetteur" : {
    "identifiantUnique" : "aeiou",
    "abonnementQuartier" : [ {
      "alertes" : [ "" ],
      "marie" : "aeiou",
      "id" : "aeiou",
      "nom" : "aeiou",
      "tous" : true
    } ],
    "utilisateurs" : [ {
      "id" : "aeiou",
      "nom" : "aeiou",
      "prenom" : "aeiou"
    } ],
    "lastUpdated" : "2000-01-23T04:56:07.000+00:00",
    "dateCreated" : "2000-01-23T04:56:07.000+00:00",
    "immeuble" : {
      "latitude" : "aeiou",
      "adresse" : "aeiou",
      "id" : "",
      "longitude" : "aeiou"
    },
    "id" : "aeiou",
    "nom" : "aeiou",
    "numeroTelephone" : "aeiou",
    "uuid" : [ "aeiou" ]
  },
  "dateCreated" : "2000-01-23T04:56:07.000+00:00",
  "etatCourant" : "aeiou",
  "typeAlerte" : "aeiou",
  "evenements" : [ {
    "dateCreated" : "2000-01-23T04:56:07.000+00:00",
    "typeEvenement" : "aeiou",
    "nomFoyerEmetteur" : "aeiou"
  } ],
  "id" : "aeiou",
  "foyerImpacte" : ""
} ]}]
     
     - parameter idFoyer: (query)  
     - parameter delta: (query)  

     - returns: RequestBuilder<[Alerte]> 
     */
    open class func apiAlerteGetAlertesProchesGetWithRequestBuilder(idFoyer: String, delta: Int32) -> RequestBuilder<[Alerte]> {
        let path = "/apiAlerte/getAlertesProches"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "idFoyer": idFoyer,
            "delta": delta.encodeToJSON()
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<[Alerte]>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

    /**
     * enum for parameter typeEvenement
     */
    public enum TypeEvenement_apiAlerteInitialiserPost: String { 
        case actSoupcon = "ACT_SOUPCON"
        case actDangerAvere = "ACT_DANGER_AVERE"
        case actConfirme = "ACT_CONFIRME"
        case actAnnule = "ACT_ANNULE"
        case obsDanger = "OBS_DANGER"
        case obsCallok = "OBS_CALLOK"
        case obsRas = "OBS_RAS"
        case obsPolice = "OBS_POLICE"
        case obsOkmerci = "OBS_OKMERCI"
        case obsVerif = "OBS_VERIF"
    }

    /**
     * enum for parameter typeAlerte
     */
    public enum TypeAlerte_apiAlerteInitialiserPost: String { 
        case cambriolage = "CAMBRIOLAGE"
        case incendie = "INCENDIE"
        case detresse = "DETRESSE"
    }

    /**
     Initialise une alerte
     
     - parameter identifiantUniqueEmetteur: (query)  
     - parameter identifiantUniqueImpacte: (query)  
     - parameter typeEvenement: (query)  
     - parameter typeAlerte: (query)  (optional)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func apiAlerteInitialiserPost(identifiantUniqueEmetteur: String, identifiantUniqueImpacte: String, typeEvenement: TypeEvenement_apiAlerteInitialiserPost, typeAlerte: TypeAlerte_apiAlerteInitialiserPost? = nil, completion: @escaping ((_ error: Error?) -> Void)) {
        apiAlerteInitialiserPostWithRequestBuilder(identifiantUniqueEmetteur: identifiantUniqueEmetteur, identifiantUniqueImpacte: identifiantUniqueImpacte, typeEvenement: typeEvenement, typeAlerte: typeAlerte).execute { (response, error) -> Void in
            completion(error);
        }
    }


    /**
     Initialise une alerte
     - POST /apiAlerte/initialiser
     - Permet la déclaration d'une alerte de sécurité dans le vsoisinage
     - BASIC:
       - type: basic
       - name: Basic
     
     - parameter identifiantUniqueEmetteur: (query)  
     - parameter identifiantUniqueImpacte: (query)  
     - parameter typeEvenement: (query)  
     - parameter typeAlerte: (query)  (optional)

     - returns: RequestBuilder<Void> 
     */
    open class func apiAlerteInitialiserPostWithRequestBuilder(identifiantUniqueEmetteur: String, identifiantUniqueImpacte: String, typeEvenement: TypeEvenement_apiAlerteInitialiserPost, typeAlerte: TypeAlerte_apiAlerteInitialiserPost? = nil) -> RequestBuilder<Void> {
        let path = "/apiAlerte/initialiser"
        let URLString = MyVillageAPIAPI.basePath + path

        let nillableParameters: [String:Any?] = [
            "identifiantUniqueEmetteur": identifiantUniqueEmetteur,
            "identifiantUniqueImpacte": identifiantUniqueImpacte,
            "typeEvenement": typeEvenement.rawValue,
            "typeAlerte": typeAlerte?.rawValue
        ]
 
        let parameters = APIHelper.rejectNil(nillableParameters)
 
        let convertedParameters = APIHelper.convertBoolToString(parameters)
 
        let requestBuilder: RequestBuilder<Void>.Type = MyVillageAPIAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: URLString, parameters: convertedParameters, isBody: false)
    }

}
